package com.liang.dao;

import com.liang.entity.StaMeetingFee;
import com.liang.entity.StaTravelexpenses;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 差旅费(StaTravelexpenses)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-26 09:50:01
 */
public interface StaTravelexpensesDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaTravelexpenses queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staTravelexpenses 查询条件
     * @param pageable          分页对象
     * @return 对象列表
     */
    List<StaTravelexpenses> queryAllByLimit(StaTravelexpenses staTravelexpenses, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staTravelexpenses 查询条件
     * @return 总行数
     */
    long count(StaTravelexpenses staTravelexpenses);

    /**
     * 新增数据
     *
     * @param staTravelexpenses 实例对象
     * @return 影响行数
     */
    int insert(StaTravelexpenses staTravelexpenses);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaTravelexpenses> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaTravelexpenses> entities);

    /**
     * 修改数据
     *
     * @param staTravelexpenses 实例对象
     * @return 影响行数
     */
    int update(StaTravelexpenses staTravelexpenses);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除差旅费
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);

    /**
     * 批量插入差旅费
     *
     * @param entities
     * @return
     */
    int insertBatch(@Param("entities") List<StaTravelexpenses> entities);

    /**
     * 获取差旅费列表
     *
     * @return
     */
    List<StaTravelexpenses> getClfList(Integer zb);

    List<StaTravelexpenses> queryByKyfh(String kyfh);

    /**
     * 项目报表（差旅费）查询
     *
     * @param XMMC 项目名称
     * @param CCDD 出差地点
     * @param QSRQ 创建起始日期
     * @param JZRQ 创建结束日期
     * @return
     */
    List<HashMap<String, Object>> searchTravelexpensesCost(Map map);

}

